#!/usr/local/bin/perl
#### ȥåХå/Խ edtb.cgi V4.00 
#### Copyright 1998-2005 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### History: 
#### 2005/04/22 V4.00 С󳫻ϡ
#### 2004/05/14 V3.00  

require 'config.ph';
require 'jcode.pl';
require 'libgns.pl';

if ( $TBLOCKFILE eq "" ) {
	$TBLOCKFILE = "$PUTDIR/$TRACKBACKDIR/log/%%lock";
}

{
	&CreateTBSemaphore();

	print "Content-Type: text/html; charset=EUC-JP\n\n";
	open( SAVEERR, ">&STDERR" );
	open( STDERR, ">$TMPDIR/cgierr.log" );
	select( STDERR ); $| = 1; select( STDOUT );
	eval {
		&main();
	};
	if ( $@ ) {
		print STDERR $@;
	}
	close( STDERR );
	open( STDERR, ">&SAVEERR" );

	&TBdoterm();
}
1;

sub main {
	local( $len );
	local( $str );
	local( @part );
	local( $i );
	local( $variable, $value );
	local( %cgi );
	local( $tbcm_mode );
	local( $id );
	local( $checked );
	local( $from );
	local( $deletecanceled );
	local( $skipcanceled );
	local( $checked_skipcanceled );
	local( $ret );
	local( $to );
	local( $s );
	local( $modestr );
	local( $date_mode );
	local( $date_year );
	local( $date_month );
	local( $checked_date_latest );
	local( $checked_date_specify );
	local( $checked_view_trackback );
	local( $checked_view_comment );
	local( $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst ) = localtime( time );
	local( $k, $v );
	local( $count );

	undef( %ENTRY );
	undef( %ENTRY_CHANGED );
	undef( %ENTRY_DELETED );

	if ( $ENV{'REQUEST_METHOD'} eq "POST" ) {
		$len = $ENV{'CONTENT_LENGTH'} + 0;
		read( STDIN, $str, $len );
	} else {
		$str = $ENV{'QUERY_STRING'};
	}

	@part = split( '&', $str );
	foreach $i (@part) {
		( $variable, $value ) = split( '=', $i );
		$value =~ tr/+/ /;
		$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
		&jcode'convert( *value, 'sjis' );
		$value =~ s/\015\012/\012/g;
		$value =~ s/\015/\012/g;
		if ( $cgi{$variable} eq "" ) {
			$cgi{$variable} = $value;
		} else {
			$cgi{$variable} .= "," . $value;
		}
	}

	print <<message;
<HTML><HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=EUC-JP">
<META HTTP-EQUIV="Content-Language" CONTENT="ja">
<TITLE>GNS ȥåХå/Խ</TITLE></HEAD><BODY>
<H1>GNS ȥåХå/Խ</H1>
message

	foreach $key ( keys %cgi ) {
		if ( $key =~ m/^id2_(.*)$/ ){
			$ENTRY{$1} = $cgi{'id_' . $1} + $cgi{'id2_' . $1};
		}
	}

	$date_mode = ( ($cgi{'date_mode'}+0) ? 1 : 0);
	$date_year = $cgi{'date_year'}+0;
	$date_month = $cgi{'date_month'}+0;

	$skipcanceled = 0;
	if ( $cgi{ 'skipcanceled' }  ) {
		$skipcanceled = 1;
	}
	$deletecanceled = 0;
	if ( $cgi{ 'deletecanceled' }  ) {
		$deletecanceled = 1;
	}

	$tbcm_mode = 1;  #latesttb
	$modestr = "[ȥåХå]";
	if ( $cgi{ 'view_mode' } == 2 ) {
		$tbcm_mode = 2;  #latestcm
		$modestr = "[Ȱ]";
	}

	if ( $date_mode ) {
		if ( ($date_year  < 1980) || ($date_year  > 2099) ||
			 ($date_month < 1   ) || ($date_month > 12  ) ) {
			$cgi{ 'command' } = "";
			$date_year = $year+1900;
			$date_month = $mon+1;
		} else {
			$s = sprintf( "%04d%02d", $date_year, $date_month );
			$ENTRY_CHANGED{$s} = 1;
		}
	} else {
		if ( ($date_year == 0) || ($date_month == 0) ) { 
			$date_year = $year+1900;
			$date_month = $mon+1;
		}
	}

	if ( $cgi{ 'command' } eq "Change it!" ) {
		&RewriteTBCMLogFile( $date_year, $date_month, $tbcm_mode, 1, $deletecanceled );
		&RewriteTBCMLogFile2( $tbcm_mode, $deletecanceled );
	}

	$checked_date_latest = "";
	$checked_date_latest = "checked" if ( !$date_mode );
	$checked_date_specify = "";
	$checked_date_specify = "checked" if ( $date_mode );

	$TB_LOG_N = 0;
	if ( $date_mode ) {
		&GetTrackbackLog( $date_year, $date_month, 1 );
	} else {
		&GetTrackbackLog( 1, $tbcm_mode, 1 );
	}

	$cmd = "View Trackback";
	$checked_view_trackback = "checked";
	$checked_view_comment = "";
	if ( $tbcm_mode == 2 ) {
		$cmd = "View Comment";
		$checked_view_trackback = "";
		$checked_view_comment = "checked";
	}

	$checked_skipcanceled = "";
	$checked_skipcanceled = "checked" if ($skipcanceled);

	print <<message;
<FORM action="edtb.cgi" method="post">
<TABLE border="1" align="center">
<TR><TD>
<INPUT TYPE="radio" NAME="date_mode" VALUE="0" $checked_date_latest>ǿ
<INPUT TYPE="radio" NAME="date_mode" VALUE="1" $checked_date_specify>
<INPUT TYPE="text" NAME="date_year" VALUE="$date_year" SIZE="4">ǯ 
<INPUT TYPE="text" NAME="date_month" VALUE="$date_month" SIZE="2">
</TD><TD>
<INPUT TYPE="radio" NAME="view_mode" VALUE="1" $checked_view_trackback>ȥåХå
<INPUT TYPE="radio" NAME="view_mode" VALUE="2" $checked_view_comment>
</TD></TR><TR><TD colspan="2" align="center">
<INPUT TYPE="checkbox" NAME="skipcanceled" VALUE="1" $checked_skipcanceled>̵Τɽʤ
<INPUT TYPE="submit" NAME="command" VALUE="View">
</TD></TR>
</TABLE>
<DIV align="right">
<A HREF="index.html">[]</A>
</DIV>
<HR>
<DIV align="center"><BIG><BIG>$modestr</BIG></BIG></DIV>
<HR>
<TABLE border="1" align="center">
<TR><TH>̵</TH><TH></TH><TH></TH><TH> / IPɥ쥹 / Agent</TH></TR>
message

	$count = 0;
	for ( $i=$TB_LOG_N-1; $i>=0; $i-- ) {
		if ( $tbcm_mode == 1 ) {
			next if ( $TB_LOG_FROM[$i] eq "COMMENT" );
		} else {
			next if ( $TB_LOG_FROM[$i] ne "COMMENT" );
		}
		$id = $TB_LOG_DATE[$i] . "_" . $TB_LOG_IP[$i];
		$id =~ s#[:/ ]##g;
		print "<INPUT TYPE=\"hidden\" NAME=\"id2_${id}\" VALUE=\"0\">\n";
		if ($skipcanceled) {
			if ( $TB_LOG_CANCELED[$i] ) {
				print "<INPUT TYPE=\"hidden\" NAME=\"id_${id}\" VALUE=\"1\">\n";
				next;
			}
		}
		print "<TR valign=\"top\">";
		$checked = "";
		$checked = "checked" if ( $TB_LOG_CANCELED[$i] );
		print "<TD><INPUT TYPE=\"checkbox\" NAME=\"id_$id\" VALUE=\"1\" $checked></TD>\n";
		if ( $TB_LOG_FROM[$i] eq "COMMENT" ) {
			$from = $TB_LOG_TITLE[$i];
		} else {
			$from =
			  "<A HREF=\"" . $TB_LOG_FROM[$i] . "\">" .
			  $TB_LOG_TITLE[$i] . " (" . $TB_LOG_BLOGNAME[$i] . ")</A>";
		}
		$to = sprintf( "<A HREF=\"%s%04d%02dt.html#%02d%02d\" target=\"_blank\">%04d/%02d/%02d</A>", 
		  $URLBASENAME,
		  $TB_LOG_YEAR[$i], $TB_LOG_MONTH[$i], $TB_LOG_DAY[$i], $TB_LOG_TITLENO[$i],
		  $TB_LOG_YEAR[$i], $TB_LOG_MONTH[$i], $TB_LOG_DAY[$i]
		);
		print "<TD>" . $TB_LOG_DATE[$i] . "</TD>";
		print "<TD><NOBR>" . $to . "</NOBR></TD>";
		print "<TD>";
		print $TB_LOG_EXCERPT[$i] . "<BR>\n";
		print $from . "<BR>\n";
		print "IP = " . $TB_LOG_IP[$i] . "<BR>\n";
		print "Agent = " . $TB_LOG_AGENT[$i] ."<BR>\n";
		print "</TR>\n";
		$count++;
	}

	if ( $count == 0 ) {
		print "<TR><TD colspan=\"4\" align=\"center\">ʳʤ</TD></TR>\n"
	}

	print <<message;
</TABLE>
<HR>
<DIV align="center">
<TABLE border="1" align="center">
<TR><TD>
<INPUT TYPE="checkbox" NAME="deletecanceled" VALUE="1">̵Τ
<INPUT TYPE="submit" NAME="command" VALUE="Change it!">
</TD></TR>
</TABLE>
</DIV>
<HR>
</FORM>
</BODY>
</HTML>
message

}

sub message {
	local( $msg ) = shift;

	print <<message;
<HTML><HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=EUC-JP">
<META HTTP-EQUIV="Content-Language" CONTENT="ja">
<TITLE>GNS ȥåХå/Ȱƺη</TITLE></HEAD><BODY>
<H1>GNS ȥåХå/Ȱƺη</H1>
<HR>
<DIV>$msg</DIV>
<HR>
<DIV><A HREF="rebtb.html">[]</A>
</BODY></HTML>
message
}

sub printerror {
	local( $msg ) = shift;

	&message( $msg );
}

####################################################################

sub RewriteTBCMLogFile {
	local( $year, $month, $tbcm_mode, $islatest, $deletecanceled ) = @_;
	local( $tblogfile );
	local( @l );
	local( $line );
	local( $nline );
	local( @a );
	local( $id );
	local( $nid );
	local( $i );
	local( $canceled );
	local( $changed );
	local( $yearmonth );
	local( $y, $m );
	local( $deleted );
	local( $deletedlogfile );
	local( $umaskback );

	$deletedlogfile = &MakeTrackbackLogFileName( 1, 3 );

	$y = $year;
	$m = $month;
	if ( $islatest ) {
		$y = 1;
		$m = $tbcm_mode;
	}
	$tblogfile = &MakeTrackbackLogFileName( $y, $m );
	if ( !(-e $tblogfile) ) {
		return (0);
	}

	$changed = 0;
	open( FIN, $tblogfile );
	$nline = 0;
	while (<FIN>) {
		$line = $_;
		$line =~ s/[\015\012]//g;
		$canceled = 0;
		$deleted = 0;
		if ( $line =~ s/^#[ ]*// ) {
			$canceled = 1;
		}
		@a = split( " ", $line, 8 );
		next if ( $#a == 0 );
		$yearmonth = substr( $a[0], 0, 6 );
		$id = $a[3] . $a[4] . "_" . $a[6];
		$id =~ s#[:/ ]##g;
		if ( defined( $ENTRY{$id} ) ) {
			if ( $canceled != $ENTRY{$id} ) {
				$changed = 1;
				$ENTRY_CHANGED{$yearmonth} = 1;
			}
			$canceled = $ENTRY{$id};
			if ( $canceled && $deletecanceled ) {
				$changed = 1;
				$ENTRY_CHANGED{$yearmonth} = 1;
				$deleted = 1;
			}
		}
		if ( $canceled ) {
			$line = "# $line";
		}
		if ( $deleted ) {
			if ( !defined( $ENTRY_DELETED{$id} ) ) {
				$ENTRY_DELETED{$id} = 1;
				$umaskback = umask( 0 );
				open( FOUT, ">>$deletedlogfile" );
				print FOUT $line, "\n";
				close( FOUT );
				umask( $umaskback );
			}
			next;
		}
		if ( $line ne "" ) {
			$l[$nline++] = $line;
		}
	}
	close( FIN );

	if ( $changed ) {
		open( FOUT, ">$tblogfile" );
		for ( $i=0; $i<$nline; $i++ ) {
			print FOUT $l[$i], "\n";
		}
		close( FOUT );
	}

	return ($changed);
}

sub RewriteTBCMLogFile2 {
	local( $tbcm_mode, $deletecanceled ) = @_;
	local( $key );
	local( $year, $month );
	local( $cmd );

	foreach $key ( keys %ENTRY_CHANGED ) {
		$year = substr( $key, 0, 4 );
		$month = substr( $key, 4, 2 );
		&RewriteTBCMLogFile( $year, $month, $tbcm_mode, 0, $deletecanceled );
		$cmd = "$PERLCMD mktbview.pl $year $month 1";
		if ( system( $cmd ) ) {
			print "<P>[$cmd]μ¹ԥ顼ȯޤ</P>\n";
			return;
		}
	}
}


####################################################################

sub CreateTBSemaphore {
	local( $abort_counter ) = 60;
	local( $not_aborted ) = 1;
	$SIG{'__DIE__'} = $SIG{'TRAP'} = $SIG{'ABRT'} = $SIG{'STOP'} = $SIG{'TERM'} = $SIG{'INT'} = $SIG{'KILL'} = $SIG{'QUIT'} = $SIG{'HUP'} = $SIG{'PIPE'} = 'TBdoterm';
	while(!mkdir($TBLOCKFILE)) {
		$abort_counter--;
		if ( $abort_counter eq 0 ) {
			$not_aborted = 0;
			last;
		}
		sleep(1);
	}

	if ( $not_aborted == 0 ) {
		&TBdoterm();
		print "Content-Type: text/plain\n\n";
		print "Cannot create semaphore [$TBLOCKFILE].  Please contact diary owner.\n";
		die "Cannot create semaphore [$TBLOCKFILE].";
	}

	return (0);
}

sub TBdoterm {
	rmdir($TBLOCKFILE);
	return;
}

####################################################################

# [EOF]
